#include <iostream>
#include <cmath>

using namespace std;

class complex {
private:
  double x,y;
  static int count_m;
public:
  complex(double xx=0.0, double yy=0.0) {
    x = xx; y=yy;
    count_m++;
  }
  complex(const complex &z) { x= z.x; y = z.y; }
  ~complex() { count_m--; }
  void print() const { cout << "(" << x << "," << y << ")"; }
  // *this += z
  void add(const complex &z) { x += z.x; y += z.y; } 
  // *this += r
  void add(double r) { x += r; } 
  // *this *= z
  void prod(const complex &z) {
    double newx = x*z.x - y*z.y;
    double newy = x*z.y + y*z.x;
    x = newx;
    y = newy;
  }
  // returns |*this|
  double abs() const {
    return sqrt(x*x+y*y);
  }
  double abs2() const {
    return x*x+y*y;
  }
  // *this = conjugate of (*this)
  void conj() { y = -y; }
  // *this /= z
  void div(const complex & z) { 
    double newx = x*z.x + y*z.y;
    double newy = -x*z.y + y*z.x;
    double az2 = z.abs2();
    x = newx/az2;
    y = newy/az2;
  } 
  static int count() { return count_m; }
  static const complex I;
};

int complex::count_m = 0;
const complex complex::I(0.0,1.0);

int main() {
  complex z(3.0,4.0), z2(5.,6.0);
  z.print(); cout << endl;
  z.add(z2);
  z.print(); cout << endl;
  z.add(8.0);
  z.print(); cout << endl;
  cout << endl;
  complex w(complex::I);
  w.prod(complex::I);
  cout << "I*I: ";
  w.print();
  cout << endl;
  cout << "Cantidad total de complejos: " << complex::count() << endl;
  complex z3(1.0,1.0),z4(2.0,2.0);
  z3.div(z4);
  z3.print();
  cout << endl;
  return 0;
}
